package org.agt.framework.idempotent.config;

import org.agt.framework.idempotent.core.aop.IdempotentAspect;
import org.agt.framework.idempotent.core.keyresolver.impl.DefaultIdempotentKeyResolver;
import org.agt.framework.idempotent.core.keyresolver.impl.ExpressionIdempotentKeyResolver;
import org.agt.framework.idempotent.core.keyresolver.IdempotentKeyResolver;
import org.agt.framework.idempotent.core.keyresolver.impl.UserIdempotentKeyResolver;
import org.agt.framework.idempotent.core.redis.IdempotentRedisDAO;
import org.springframework.boot.autoconfigure.AutoConfiguration;
import org.agt.framework.redis.config.AgtRedisAutoConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.core.StringRedisTemplate;

import java.util.List;

@AutoConfiguration(after = AgtRedisAutoConfiguration.class)
public class AgtIdempotentConfiguration {

    @Bean
    public IdempotentAspect idempotentAspect(List<IdempotentKeyResolver> keyResolvers, IdempotentRedisDAO idempotentRedisDAO) {
        return new IdempotentAspect(keyResolvers, idempotentRedisDAO);
    }

    @Bean
    public IdempotentRedisDAO idempotentRedisDAO(StringRedisTemplate stringRedisTemplate) {
        return new IdempotentRedisDAO(stringRedisTemplate);
    }

    // ========== 各种 IdempotentKeyResolver Bean ==========

    @Bean
    public DefaultIdempotentKeyResolver defaultIdempotentKeyResolver() {
        return new DefaultIdempotentKeyResolver();
    }

    @Bean
    public UserIdempotentKeyResolver userIdempotentKeyResolver() {
        return new UserIdempotentKeyResolver();
    }

    @Bean
    public ExpressionIdempotentKeyResolver expressionIdempotentKeyResolver() {
        return new ExpressionIdempotentKeyResolver();
    }

}
